#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>
#include <wiiuse/wpad.h>

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;


#ifdef __wii
#define QUIT_BUTTON PAD_BUTTON_START
#else
#define QUIT_BUTTON PAD_BUTTON_START
#endif

//---------------------------------------------------------------------------------
void ScanPads() {		
//---------------------------------------------------------------------------------
#ifdef __wii__
	WPAD_ScanPads();
#else
	PAD_ScanPads();
#endif
}


//---------------------------------------------------------------------------------
u32 ButtonsDown() {		
//---------------------------------------------------------------------------------
#ifdef __wii__
	return WPAD_ButtonsDown(0);
#else
	return PAD_ButtonsDown(0);
#endif
}

//---------------------------------------------------------------------------------
int main(int argc, char **argv) {
//---------------------------------------------------------------------------------

	VIDEO_Init();

#ifdef __wii__
	WPAD_Init();
#else
	PAD_Init();
#endif

	rmode = VIDEO_GetPreferredMode(NULL);

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));

	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);

	VIDEO_Configure(rmode);

	VIDEO_SetNextFramebuffer(xfb);

	VIDEO_SetBlack(FALSE);

	VIDEO_Flush();

	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

	printf("\x1b[2;0H");

	printf("Hello World!");

	while(1) {

		ScanPads();

		u32 pressed = ButtonsDown(0);

		if ( pressed & QUIT_BUTTON ) exit(0);

		VIDEO_WaitVSync();
	}

	return 0;
}
